* Example 1
* From Guimaraes & Portugal (2009)
* Estimates a linear regression with one fixed effect
* Replicates the estimates obtained with xtreg as in page 400 of the [XT] Stata Manual v10.

set more off
log using example1.log,replace

use nlswork
*webuse nlswork
generate age2 = age^2
generate ttl_exp2 = ttl_exp^2
generate tenure2 = tenure^2
generate double fe1=0
local rss1=0
local dif=1
local i=0
while abs(`dif')>epsdouble() {
quietly {
regress ln_w age* ttl_exp* tenure* not_smsa south fe1
local rss2=`rss1'
local rss1=e(rss)
local dif=`rss2'-`rss1'
capture drop yhat
predict double yhat 
generate double temp1=ln_w-yhat+_b[fe1]*fe1
capture drop fe1
egen double fe1=mean(temp1), by(idcode)
capture drop temp1
local i=`i'+1
}
}
di "Total Number of Iterations --> " `i'
regress ln_w age* ttl_exp* tenure* not_smsa south fe1

log close
exit

