* Example2
* From Guimaraes & Portugal (2009)
* Estimates a linear regression with two fixed effects
* Replicates the estimates in Cornelissen 2008, Stata J 8: 170-189.
* felsdvsimul is the ancillary dataset in Cornelissen 2008.

set more off
log using example2.log,replace

use felsdvsimul, clear
generate double temp=0
generate double fe1=0
generate double fe2=0
local rss1=0
local dif=1
local i=0
while abs(`dif')>epsdouble() {
quietly {
regress y x1 x2 fe1 fe2
local rss2=`rss1'
local rss1=e(rss)
local dif=`rss2'-`rss1'
capture drop res
predict double res, res
replace temp=res+_b[fe1]*fe1, nopromote
capture drop fe1
egen double fe1=mean(temp), by(i)
replace temp=res+_b[fe2]*fe2, nopromote
capture drop fe2
egen double fe2=mean(temp), by(j)
local i=`i'+1
}
}
di "Total Number of Iterations --> " `i'
regress y x1 x2 fe1 fe2

log close
