* Example 5
* From Guimaraes & Portugal (2009)
* Estimates Poisson Regression with two fixed effects

set more off
log using example5.log,replace

*webuse ships, clear
use ships, clear
local dif=1
xi: poisson acc op_75_79 i.yr_con i.ship, nolog
keep if e(sample)
bys ship: egen sumy1=total(acc)
bys yr_con: egen sumy2=total(acc)
gen double off=0
gen double temp=0
gen double temp1=0
gen double temp2=0
gen double fe1=0
gen double fe2=0
local ll1=0
local i=0
while abs(`dif')>epsdouble() {
qui poisson acc op_75_79, nocons offset(off) nolog
local ll2=`ll1'
local ll1=e(ll)
capture drop xb
predict double xb, xb
qui replace temp1=xb-off+fe2, nopromote
capture drop sumx
bys ship: egen double sumx=total(exp(temp1))
qui replace fe1=log(sumy1/sumx), nopromote
qui replace temp2=xb-off+fe1, nopromote
capture drop sumx
bys yr_con: egen double sumx=total(exp(temp2))
qui replace fe2=log(sumy2/sumx), nopromote
qui replace off=fe1+fe2
local dif=`ll2'-`ll1'
local i=`i'+1
}
di "Total Number of Iterations --> " `i'
poisson acc op_75_79, nocons offset(off) nolog

log close
exit

