* Example 6
* From Guimaraes & Portugal (2009)
* Estimates Negative Binomial Regression with one fixed effect

set more off
log using example6.log,replace

*webuse ships, clear
use ships
xi: nbreg acc op_75_79 co_65_69 co_70_74 co_75_79 i.ship, nolog
keep if e(sample)
egen id=group(ship)
qui sum id
local maxg=r(max)
local dif=1
local ll1=0
local i=0
gen double off1=0
gen double off2=0
while abs(`dif')>epsdouble() {
qui nbreg acc op_75_79 co_65_69 co_70_74 co_75_79, nocons offset(off1) nolog
local lna=log(e(alpha))
constraint define 1 [lnalpha]_cons=`lna'
local ll2=`ll1'
local ll1=e(ll)
capture drop xb
predict double xb, xb
qui replace off2=xb-off1, nopromote
forval j=1/`maxg' {
qui nbreg acc if id==`j', offset(off2) constraint(1) nolog
qui replace off1=_b[_cons] if e(sample), nopromote
}
local dif=`ll2'-`ll1'
local i=`i'+1
}
di "Total Number of Iterations -->" `i'
nbreg acc op_75_79 co_65_69 co_70_74 co_75_79, offset(off1) nocons nolog

log close
exit

